/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-actionmenu.js 3176 2008-07-08 14:30:12Z josh $
*/

/***************************************************************/
    BM.ActionMenu = new Object;
/*  Enable/disable checkbox actions
****************************************************************/
BM.Behavior.register( {
    // main edit menu
    '#editorMenu:click' : function(e,evt) {
        BM.ActionMenu.handleClick('editorMenu',evt,'editorActionMenu');
    },
    '#editorActionMenu a.bmcpMenuDelete:click' : function(e,evt) {
        BM.ActionMenu.deleteChecked( 'editorMenu',
          {script:'bm-editor.cgi',rm:'delete',path:[BM.EditType]}
        );
        Event.stop(evt); return false;
    },
    '#editorActionMenu a.bmcpMenuStatus:click' : function(e,evt) {
        BM.ActionMenu.getNewStatus('editorMenu');
        Event.stop(evt); return false;
    },
    '#editorActionMenu a.changesec:click' : function(e,evt) {
        return BM.ActionMenu.editorSubmit('choose-sec',evt);
    },
    '#editorActionMenu a.copy:click' : function(e,evt) {
        return BM.ActionMenu.editorSubmit('copy',evt);
    },
    '#editorActionMenu a.copyxsite:click' : function(e,evt) {
        return BM.ActionMenu.editorSubmit('copyxsite',evt);
    },
    '#BMeditorMenuStatus:submit' : function(form,evt) {
        BM.ActionMenu.submitStatus(form, 'editorMenu', BM.EditType);
        Event.stop(evt); return false;
    },
    
    //account menu
    '#accountMenu:click' : function(e,evt) {
        BM.ActionMenu.handleClick('accountMenu',evt,'accountActionMenu');
    },
    '#accountActionMenu a.bmcpMenuDelete:click' : function(e,evt) {
        BM.ActionMenu.deleteChecked( 'accountMenu',
          {script:'bm-account.cgi',rm:'delete'}
        );
        Event.stop(evt); return false;
    },
    
    //review menu
    '#reviewMenu:click' : function(e,evt) {
        BM.ActionMenu.handleClick('reviewMenu',evt,'reviewActionMenu');
    },
    '#reviewActionMenu a.bmcpMenuDelete:click' : function(e,evt) {
        BM.ActionMenu.deleteChecked( 'reviewMenu',
          {script:'bm-review.cgi',rm:'ajax-delete'},
          {ajax:1, lang:'Review:Really delete this site?'}
        );
        Event.stop(evt); return false;
    },
    
    //moderator menu
    '#modMenu:click' : function(e,evt) {
        BM.ActionMenu.handleClick('modMenu',evt,'modActionMenu');
    },
    '#modActionMenu a.bmcpMenuDelete:click' : function(e,evt) {
        BM.ActionMenu.deleteChecked( 'modMenu',
          {script:'bm-mod.cgi',rm:'delete'}
        );
        Event.stop(evt); return false;
    },
    '#modActionMenu a.changeapprove:click' : function(e,evt) {
        var form = $('modMenu');
        if (form && BM.ActionMenu.isActive(form)) {
        BM.Ajax.inProgress(BM.alert().contentDiv);
            form.action = BM.url({script:'bm-mod.cgi',rm:'approve'});
            form.submit();
            form = null;
        }
        Event.stop(evt); return false;
    },
    '#modActionMenu a.changespam:click' : function(e,evt) {
        var form = $('modMenu');
        if (form && BM.ActionMenu.isActive(form)) {
        BM.Ajax.inProgress(BM.alert().contentDiv);
            form.action = BM.url({script:'bm-mod.cgi',rm:'mark-spam'});
            form.submit();
            form = null;
        }
        Event.stop(evt); return false;
    }
    
    //library items are in library js
});

BM.ActionMenu = {
    'handleClick' : function(form,event,amenu) {
        //event is a click somewhere in the main form
        var i = Event.element(event);
        if (!i.type || i.type != 'checkbox') return;
        if (i.id && i.id == 'bmcpCheckAll') {
            var check = i.checked;
            Form.getInputs(form,'checkbox').each(function(c) {
              c.checked=check;
            });
        }    
        BM.ActionMenu.update(amenu,form);
    },
    'update' : function(menu, form) {
        if ( !( menu = $(menu) ) ) return;
        var active = BM.ActionMenu.isActive(form);
        if (active) {
            Element.setOpacity(menu, 1);
        }
        else {
            Element.setOpacity(menu, 0.5);        
        }
    },
    'isActive' : function(form) {
        if ( !( form = $(form) ) ) return false;
        return Form.getInputs(form,'checkbox').detect( function(box) {
            return box.checked && !box.id;
        } );
    },
    'editorSubmit' : function(mode,evt) {
        var form = $('editorMenu');
        if (form && BM.ActionMenu.isActive(form)) {
            form.action = BM.url({script:'bm-editor.cgi',rm:mode,path:[BM.EditType]});
            form.submit();
            form = null;
        }
        Event.stop(evt); return false;
    },
    'deleteChecked' : function(form,urlOpt,options) {
        if ( !( form = $(form) ) ) return false;
        if(!BM.ActionMenu.isActive(form)) return false;
        if(typeof options != 'object') options = {};
        var action, showProg;
        if (options.ajax) {
            action = function() {
                var checks = Form.getInputs(form,'checkbox').findAll(
                    function(box){ return box.checked; }
                );
                var modal = BM.alert('');
                var onsuccess = function(httpReq) {
                    var ajaxJSON = BM.Ajax.parseJSON(httpReq);
                    if (BM.Ajax.loginRequired(ajaxJSON)) {
                        modal.remove();
                    }
                    else if ( !ajaxJSON.valid ) { //error
                        BM.Ajax.showMessage(ajaxJSON,modal.contentDiv);
                    }
                    else { //got it, zap the rows
                        modal.remove();
                        checks.each(function(box){
                            var tr = $('bmTableRow' + box.value);
                            var col = Element.hasClassName(tr, 'odd')
                                    ? '#deefef' : '#eeffff';
                            BM.FX.flash( tr, {
                                startcolor:col,
                                endcolor:'#ff6666',
                                restorecolor:'#ff6666',
                                afterFinish: function(){Element.remove(tr)},
                                duration: 1.0
                            });
                        });
                    }
                }
                form.action = BM.url( urlOpt );
                BM.Ajax.submitForm(form, modal.contentDiv, {onsuccess:onsuccess});
            };
        }
        else {
            showProg = 1;
            action = function() {
                form.action = BM.url( urlOpt );
                form.submit();
             };
        }
        var message = options.lang;
        if (!message) message = 'ActionMenu:Really delete?'
        new BM.Confirm( {
            message:BM.Lang._(message),
            action: action,
            showProg : showProg
        } );
    },
    'getNewStatus' : function(formId, options) {
        var form;
        if ( !( form = $(formId) ) ) return false;
        if(!BM.ActionMenu.isActive(form)) return false;
        if ( typeof options != 'object' ) options = {};
        var tempform = new BM.TempForm(
          { id: 'BM' + formId + 'Status', className:'bmcpMenuStatus' },
          { modal : { width : BM.alertWidth } } );
        if (!options.fields) { //default is published status
            var options = ['x', 'draft','edit','ready'];
            if (BM.canPublish) options.push('published');
            options.fields = [
              [ 'value_list', 'BMTEMP_MenuStatus__value',
                { options:options,
                  labels: {
                    'x' : BM.Lang._('ActionMenu:No change'),
                    'draft' : BM.Lang._('ActionMenu:Draft'),
                    'edit'  : BM.Lang._('ActionMenu:Editing'),
                    'ready' : BM.Lang._('ActionMenu:Ready to publish'),
                    'published' : BM.Lang._('ActionMenu:Publish')
                  },
                  label : BM.Lang._('ActionMenu:Status')
                }
              ],
              [ 'priority_slider', 'BMTEMP_MenuStatus__priority',
                { label : BM.Lang._('ActionMenu:Priority'), value: 500 }
              ]
            ];
            if (BM.EditUsers) {
                options.fields.push(
                  ['value_list', 'BMTEMP_MenuStatus__owner',
                    { options:BM.EditUsers.uid,
                      labels:BM.EditUsers.uname,
                      label : BM.Lang._('ActionMenu:Owner')
                    }
                  ]
                );
            }
        }
        tempform.addFields(options.fields);
        tempform.addSubmitCancel();
        tempform.displayModal();
        return false;
    },
    'submitStatus' : function(tempform, formName, pageType) {
        var status = $F('BMTEMP_MenuStatus__value');
        var pri = $F('BMTEMP_MenuStatus__priority');
        var own = '';
        var ownf = $('BMTEMP_MenuStatus__owner');
        if (ownf) { own = $F(ownf) }

        var form = $(formName);
        form.action = BM.url(
          { script:'bm-editor.cgi',rm:'change-status',path:[pageType,status,pri,own] }
        );
        BM.Ajax.inProgress(tempform.up('div.bm_ModalMessage'));
        form.submit();
        return false;
    }
};
