/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-editor.js 3233 2008-08-21 12:47:26Z josh $
*/

BM.Editor = {
    toggleFileReplace : function(baseID) {
        var trig = $(baseID + '__TRIG');
        BM.FX.toggle(trig, baseID + '__REPLACE');
        var disabled = Element.hasClassName(trig,'bmTriggered') ? false : true;
        $A($(baseID+'__REPLACE').getElementsByTagName('input')).each(function(f){
            if (f.type == 'file' || f.type =='text') f.disabled = disabled;
        });
    },
    getMainContent : function() {
        var f=$('EditorScreen'),tabs,text;
        if(f) { tabs = f.getInputs('radio','content') }
        if (!tabs) { return }
        var ctype = tabs.find(function(r){return r.checked} ).value;
        var text = (ctype == 'RichText')
          ? FCKeditorAPI.GetInstance('RichTextcontent').GetXHTML()
          : $F(ctype+'content');
        return ctype + ':' + text;   
    },
    diffVersion : function(url) {
        var text=BM.Editor.getMainContent();
        var status = 'bmAjax' + BM.random();
        var modal = BM.alert('<div id="' + status + '"></div>');
        BM.Ajax.request(
            url,
            { 'parameters'  : {'difftext':text},
              'onLoading' : function() { BM.Ajax.inProgress(status); },
              'onSuccess' : function(httpReq) {
                BM.Editor.catchDiffRequest(httpReq, modal); modal=null;
              },
              'onFailure' : function(httpReq) {
                BM.Ajax.error(httpReq, status); modal=null;
              }
            }
        );
    },
    catchDiffRequest : function(httpReq,modal) {
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON,modal)){return;}
        if (ajaxJSON.data) {
            var dmp = new diff_match_patch();
            var d = dmp.diff_main(ajaxJSON.data.o,ajaxJSON.data.n);
            dmp.diff_cleanupSemantic(d);
            modal.contentDiv.innerHTML = ajaxJSON.data.intro
              + '<div class="bmdiffContainer">'
              + dmp.diff_prettyHtml(d)
              + '</div>';
            $('bmdiffRevert').onclick=function(){
              BM.Editor.revertText(ajaxJSON.data.rtype,ajaxJSON.data.rtext);
              modal.remove();
              return false;
            };
        }
        else {
            modal.contentDiv.innerHTML = ajaxJSON.error || ajaxJSON.html || ajaxJSON;
            modal=null;
        }
    },
    revertText : function(type,text) {
        var field=$(type+'content');
        var tab=$(type+'Tab-content');
        if (!field || !tab) return;
        var fck;
        if(type=='RichText'&&(fck=FCKeditorAPI.GetInstance('RichTextcontent'))){
            fck.SetHTML(text);
        }
        else {
            field.value=text;
        }
        tab.checked=true;
        BM.RadioTab.select(tab);
    }
};
BM.Behavior.register( {
    // edit screen items (all for minicontent)
    '#bmcpMainBody:click' : function(e,evt) {
      var cn = e.className || '';
      if ( cn.indexOf('bmcp_mini_edit')!= -1 ) {
        BM.Mini.showEditor(e);
        Event.stop(evt); return false;      
      }
      else if ( cn.indexOf('bmcp_mini_delete')!= -1 ) {
        BM.Mini.confirmDelete(e);
        Event.stop(evt); return false;      
      }
    },
    '#bmcpMetaPanel:click' : function(e,evt) {
      var cn = e.className || '';
      if ( cn.indexOf('bmdiff')!= -1 ) {
        BM.Editor.diffVersion(e.href);
        Event.stop(evt); return false;      
      }
    },
    '#EditorScreen:submit' : function() {
        $$('#EditorScreen input.bmcp_sortfield').each( function(field){
            field.value=BM.Sort.serialize(field.parentNode);
        });
    },
    '#BM_MFILTER:keypress' : function(e,evt) {
        if( (evt.charCode || evt.keyCode) == Event.KEY_RETURN) {
            Event.stop(evt);
            BM.Browser.newSearch();
        }
    },
    '#BM_MFIND:click' : function(e,evt) {
        Event.stop(evt);
        BM.Browser.newSearch();    
    },
    'form:click' : function(e,evt) {
      if (e.tagName == 'A') {
        var c = e.className || "";
        if (c.indexOf('fileReplace') != -1) {
            var match= e.id.match(/^(.*)__TRIG$/);
            if (!match) return;
            BM.Editor.toggleFileReplace(match[1]);
            Event.stop(evt); return false;
        }
        else if (c.indexOf('cancelFileReplace') != -1) {
            var match= e.id.match(/^(.*)__CANCEL$/);
            if (!match) return;
            BM.Editor.toggleFileReplace(match[1]);
            Event.stop(evt); return false;
        }
        else if (c.indexOf('bmimageUFtog') != -1) {
            var match= e.id.match(/^(.*)__(U|F)TRG$/);
            if (!match) return;
            var baseID = match[1];
            if (match[2] == 'U') {
                $(baseID + '__UTOG').style.display = 'inline';
                $(baseID + '__FTOG').style.display = 'none';
                BM.FX.removeClass(baseID + '__FTRG', 'linkSelected');
                $(baseID).disabled = true;
                $(baseID+'__URL').disabled = false;
            }
            else {
                $(baseID + '__FTOG').style.display = 'inline';
                $(baseID + '__UTOG').style.display = 'none';
                BM.FX.removeClass(baseID + '__UTRG', 'linkSelected');
                $(baseID).disabled = false;
                $(baseID+'__URL').disabled = true;
            }
            BM.FX.addClass(e, 'linkSelected');
            Event.stop(evt); return false;
        }
      }
    }
} );

/***************************************************************/
    BM.Mini = new Object;

/*  Functions specific to the adding and editing related
    minicontent objects to primary content objects.
****************************************************************/

BM.Mini.schema = new Object;
BM.Mini.obj = new Object;
BM.Mini.relation = new Object;
BM.Mini.iframe = new Object;


BM.Mini.showEditor = function(link) {
    if (!(link = $(link))) return;
    var linkID = link.id;
    var relation;
    var option = new Object;
    if (linkID.indexOf('EDITLINK') > 0) {
        var match = linkID.match(/^BM_MINI_EDITLINK_(\S+?)\-(\S+?)\-(\d+)$/)
        if (!match) return;
        relation = match[1];
        option.objType = match[2];
        option.objID = match[3];
    }
    else {
        var match = linkID.match(/^BM_MINI_ADDLINK_(\S+?)\-(\S+)$/)
        if (!match) return;
        relation = match[1];
        option.objType = match[2];
    }
    new BM.Mini.Editor(relation, option);
}

BM.Mini.Editor = function(relation, option) {
    if (typeof option != 'object') option = {};
    var relationObj = BM.Mini.relation[relation];
    if (!relationObj) return;

    // get object type/id and, if applicable, pointer id and metadata
    var uniqueID;
    if (relationObj.points) {
        this.points = 1;
        if (option.objID) { // requesting existing object
            var pointer = relationObj[option.objID];
            if (!pointer) return;
            this.pointID = option.objID;
            this.type = pointer[0];
            this.objID = pointer[1];
            this.meta = pointer[2];
        }
        else {
            this.type = option.objType;
            this.meta = {};
        }
    }
    else {
        this.type = relationObj.types[0];
        this.objID = option.objID;
    }
    if (!this.type || !BM.Mini.schema[this.type]) return false;
    this.suffix = BM.Mini.buildSuffix(relation, this.type, option.objID);
    this.relation = relation;
    this.clickOnLoad = [];

    if ( BM.Mini.atLimit(relation) && !this.objID ) { // new item over limit
        BM.alert( BM.Lang._('Mini:At limit') );
        return;
    }
    
    // tempform options
    var remoteMethod = BM.Mini.iframe[this.type] ? 'iframe' : 'ajax';
    var formOpts = {
        remote:     remoteMethod,
        modal:      option.modal,
        toggle:     option.toggle,
        trigger:    option.trigger
    };
    formOpts.oncomplete = option.oncomplete || this.handleResponse;
    var containerID, heading;
    var editOrAdd = this.objID ? 'Mini:Edit ' : 'Mini:Add ';
    formOpts.heading = BM.Lang._(editOrAdd + this.type); 

    //form attributes
    var attr = {id: 'BM_MINI_FORM_' + this.suffix};
    if (BM.tempElements[attr.id]) return; // already got it.
    //get info about main content element, and build URL
    var contentLabel = BM.Mini.contentLabel(), contentID = BM.Mini.contentID();
    if (!contentLabel || !contentID) {
        BM.alert( BM.Lang._('Mini:Unknown content type or ID') );
        return;
    }

    //path uses option.objID not this.objID to use pointer if appropriate
    var path = [contentLabel, contentID, relation, this.type];
    if(option.objID) path.push(option.objID);
    attr.action = BM.url( {
        script: 'bm-editor.cgi',
        rm: 'ajax-save-mini',
        path: path
      } );
    //generate the form
    this.tempform = new BM.TempForm(attr, formOpts);
    this.createFields();
    var container;

    //display modal
    if (this.tempform.modal) {
        this.tempform.displayModal();
        if (this.points) this.initBrowser();
        return;
    }
    
    //display toggle/trigger
    if (option.toggle) container = option.toggle.target;
    else if (option.trigger) container = option.trigger.target;
    else container = 'BM_MINI_EDIT_' + this.suffix;

    if (!(container = $(container))) return; // nowhere to show it.
    var insideDiv = container.firstChild; // use first div if available
    if (insideDiv && insideDiv.tagName.toLowerCase() == 'div') container = insideDiv;
    this.tempform.addAsChildOf(container);
    if (this.points) this.initBrowser();
}

BM.Mini.Editor.prototype.initBrowser = function() {
    new BM.Browser( {relation: this.relation, objType: this.type } );
}

BM.Mini.Editor.prototype.createFields = function() {
    //add fields using BM.Mini.schema outline and BM.Mini.obj values
    var objValues = {};
    if (   this.objID
        && BM.Mini.obj[this.type]
        && BM.Mini.obj[this.type][this.objID] )
    {
        objValues = BM.Mini.obj[this.type][this.objID];
    }
    var schema = BM.Mini.schema[this.type];
    var suffix = '_' + this.suffix;
    if (this.points) {
        var objField = this.objID ? 'Edit' : 'New';
        var lib_suffix = this.relation + '-' + this.type;
        var fields, preamble;
        if (objValues.can_edit || !this.objID) {
            fields = this.formatFields(schema, objValues);
            preamble = '';
        }
        else {
            fields = [];
            var rule = BM.Browser.rules[this.type] || BM.Browser.rules.generic;
            preamble = BM.jsont(objValues, rule)
              + '<div class="bmcpSupportText">' + BM.Lang._('Mini:Cannot edit')
              + '</div>';
        }
        
        //for authors, new should always go to library
        var checkLibrary = ( this.type == 'person' && objField == 'New' );
        var tabs = [
          { text : BM.Lang._('Mini:' + objField + ' ' + this.type),
            value : objField,
            id : 'BM_TAB_' + objField + suffix,
            fields : fields,
            preamble: preamble,
            checked : !checkLibrary
          },
          { text : BM.Lang._('Mini:Library ' + this.type),
            value: 'Library',
            id : 'BM_TAB_Library' + suffix,
            checked : checkLibrary,
            fields : [ ['library', 'library', {
                suffix: lib_suffix,
                sort: BM.Lang._('Browser:Sort'),
                alpha: BM.Lang._('Browser:Alphabetically'),
                recent: BM.Lang._('Browser:Recent')
             } ] ]
          }
        ];
        this.tempform.addTabbedFields(
            'BM_TAB' + suffix, tabs, {containerClass : 'bmcp_mini_tabbed'}
        );
        var metaSchema = BM.Mini.relation[this.relation].meta;
        if (metaSchema) {
            var oType = this.type;
            metaSchema = metaSchema.findAll( function(f) {
                return !f[2].depend || BM.Mini.depend[oType][f[2].depend];
            });
            this.tempform.addFields( this.formatFields(metaSchema, this.meta) );
        }
        this.tempform.addFields( [
            [ 'hidden', 'BM_LINKED_ID' + suffix, {value:this.objID} ],
            [ 'hidden', 'BM_LIB_ID_' + lib_suffix, {value: ''} ],
          ] );
    }
    else {
        this.tempform.addFields( this.formatFields(schema, objValues) );
    }
    //add cancel, edit fields
    this.tempform.addSubmitCancel();
}


BM.Mini.Editor.prototype.formatFields = function(schema, objValues) {
    var editor = this;
    var fields = [];
    schema.each(function(fieldArray){
        var fieldName = fieldArray[1];
        var fieldOpts = fieldArray[2];
        if (typeof fieldOpts != 'object') fieldOpts = {};
        if ( fieldArray[0] == 'body_position'
          && ( editor.type != 'image' || $F('BM_CONTENT_LABEL') != 'page') )
        {
            //bump gallery off of the list of options; dereference first.
            var replace = {};
            $H(fieldOpts).keys().each(
                function(key) { replace[key] = fieldOpts[key]; }
            );
            fieldOpts = replace;
            fieldOpts.options = fieldOpts.options.toArray();
            fieldOpts.options.shift();
        }
        if (fieldName && objValues[fieldName] != null) {
            fieldOpts.value = objValues[fieldName];
        }
        else {
            fieldOpts.value = fieldOpts['default'];
        }
        fields.push( [
          fieldArray[0],
          'BM_MINI_' + fieldName + '_' + editor.suffix,
          fieldOpts
        ] );
    });
    return fields;    
}

BM.Mini.Editor.prototype.handleResponse = function(ajaxJSON, tempform) {
    var data = ajaxJSON.data;
    if (!data) {
        BM.Ajax.showMessage(ajaxJSON, tempform.status);
        return false;
    }

    //verify data and collect objID
    var objID;
    var err;
    if (!data.obj) err = 'Mini:No object data';
    else if (!data.type) err = 'Mini:No data type specified in response';
    else if (!BM.Mini.schema[data.type]) err = 'Mini:Unknown data type';
    else if (!data.relationName) err = 'Mini:No relationship type specified';
    else if (!BM.Mini.relation[data.relationName]) err = 'Mini:Unknown relationship';
    else if (BM.Mini.relation[data.relationName].types.indexOf(data.type) < 0)
      err = 'Mini:Relationship/type mismatch';
    else {
        var ids = [];
        for (var id in data.obj) ids.push(id);
        objID = ids[0];
        if (!objID) err = 'Mini:No object ID specified';
    }
    if (err) {
        var preamble = BM.Lang._('Mini:Bad data response');
        BM.Ajax.showMessage({error:BM.Lang._(err)}, tempform.status, preamble);
        return false;
    }
    
    //update object/relation info and apply preview html
    Object.extend(BM.Mini.obj[data.type], data.obj);
    var previewID = objID;
    if (data.pointer_id) {
        previewID = data.pointer_id;
        BM.Mini.relation[data.relationName][previewID] =
          data.relation[previewID];
    }
    var itemID = 'BM_MINI_'
      + BM.Mini.buildSuffix(data.relationName, data.type, previewID);
    var item = $(itemID);
    var list = $('BM_LIST_' + data.relationName);
    var sortable = Element.hasClassName(list, 'bmcp_sortable_list');
    if (item) {
        item.innerHTML = data.preview;
    }
    else { //new, have to add it.
        if (!list) return true; // no such list, just fail quietly
        item = Builder.node( 'li', {id: itemID} );
        item.innerHTML = data.preview;
        list.appendChild(item);
        setTimeout(function(){BM.Mini.updateTriggers(data.relationName)}, 200);
    }
    if ( sortable ) BM.Sort.init(list.parentNode);
    BM.Ajax.showMessage(BM.Lang._('Mini:Confirm saved'), tempform.status);
    return true;
}


BM.Mini.buildSuffix = function(relation, type, objID) {
    var suffix =  relation + '-' + type;
    if (objID) suffix += '-' + objID;
    return suffix;
};

BM.Mini.confirmDelete = function(link) {
    if (!(link = $(link))) return;
    var match = link.id.match(/^BM_MINI_DEL_((\S+?)\-(\S+?)\-(\d+))$/)
    if (!match) return;
    var suffix = match[1]
    var relation = match[2];
    var objType = match[3];
    var objID = match[4];

    var relationObj = BM.Mini.relation[relation];
    if (!relationObj) return;
    var msg;
    if (relationObj.points) {
        msg = BM.Lang._('Mini:Really remove this') + ' '
          + BM.Lang._('Mini:' + objType) + '?<br />'
          + BM.Lang._('Mini:Remove explain');
    }
    else {
        msg = BM.Lang._('Mini:Really delete this') + ' '
          + BM.Lang._('Mini:' + objType) + '?<br />'
          + BM.Lang._('Mini:Delete explain');
    }
    
    var status = 'BM_MINI_AJAX_' + suffix;    
    var loading = function() { BM.Ajax.inProgress(status) };
    var success = function(httpReq) {
        BM.Ajax.clearStatus(status);
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON)) { //login
            return;
        }
        else if (ajaxJSON.error || !ajaxJSON.valid) { // show error in modal
            var msg = ajaxJSON.error || ajaxJSON;
            BM.alert(msg);
        }
        else { // successful, take it off the page
            var item = $('BM_MINI_' + suffix);
            var list = $('BM_LIST_' + relation);
            if (list && item) {
                BM.FX.hide(item,{effect:'squish'});
                setTimeout(function(){
                    list.removeChild(item);
                    BM.Mini.updateTriggers(relation);
                }, 2000);
            }
        }
    };
    var error = function(httpReq) {
        BM.Ajax.clearStatus(status);
        var status = httpReq.statusText == 'OK' ? '' : ': ' + httpReq.statusText;
        BM.alert('<span class="bm_ajaxNotOK">' + BM.Lang._('Ajax:error')
          + status + '</span>'); 
    };

    var contentLabel = BM.Mini.contentLabel(), contentID = BM.Mini.contentID();
    if (!contentLabel || !contentID) {
        BM.alert( BM.Lang._('Mini:Unknown content type or ID') );
        return;
    }
    var path = [contentLabel, contentID, relation, objType, objID];
    var url = BM.url({ script: 'bm-editor.cgi', rm: 'ajax-delete-mini', path: path });
    new BM.Confirm( { 
        message: msg,
        action: function() { BM.Ajax.request(
          url,
          { 'method' : 'post', 'onLoading' : loading,
            'onSuccess' : success, 'onFailure' : error } );
        }
    });
};

BM.Mini.contentLabel = function() {
    var label = $('BM_CONTENT_LABEL') ? $F('BM_CONTENT_LABEL') : '';
    if (!label) return '';
    if ( $('BM_CONTENT_SUBTYPE') && $F('BM_CONTENT_SUBTYPE') ) {
        label += '.' + $F('BM_CONTENT_SUBTYPE');
    }
    return label;
};

BM.Mini.contentID = function() {
    return $('BM_CONTENT_ID') ? $F('BM_CONTENT_ID') : '';
};


BM.Mini.numItems = function(relation) {
    return $$('#BM_LIST_' + relation + ' div.bmcp_miniItem').length;
}

BM.Mini.atLimit = function(relation) {
    var limit = BM.Mini.relation[relation].limit_num;
    if (!limit) return 0;
    return BM.Mini.numItems(relation) >= limit;
};

BM.Mini.updateTriggers = function(relation) {
    var triggers = 'BM_MINI_TRIGGERS_' + relation;
    if (BM.Mini.atLimit(relation)) {
        BM.FX.hide(triggers);
    }
    else {
        BM.FX.reveal(triggers);
    }
}

BM.Mini.hasRequired = function() {
    var msg = '';
    for (var relation in BM.Mini.relation) {
        if (BM.Mini.relation[relation].required && !BM.Mini.numItems(relation) ) {
            msg += '<li>' + BM.Lang._('Mini:required:' + relation) + '</li>';
        }
    }
    return msg ? msg : 1;
}

/***************************************************************/
    BM.Browser = Class.create();

/*  Browse mini-content objects in the browser
****************************************************************/

BM.Browser.rules = {
    'generic' : {
        'self' : '<strong>{title}<\/strong>'
    },
    'page' : {
        'self' : '<strong>{title}<\/strong>{@pubstatus($)}',
        'pubstatus' : function(self) {
            return (!self.pub_status || self.pub_status != 'published')
              ? '<p class="bmcpSupportText"><em>'
                + BM.Lang._('Mini:Currently unpublished') + '</em></p>'
              : '';
        }
    },
    'document' : {
        'self' : '<strong class="docIconSm{@iconClass($.filename)}">'
          + '{title}</strong><div class="bmcpSupportText">'
          + '<p>{filename}</p><p><a href="{@url($.filename)}" '
          + 'class="preview">' + BM.Lang._('TempForm:Show me') + '</a></p></div>',
        'iconClass' : function(filename) {
            var match = filename.match(/\.([a-zA-Z0-9]+)$/);
            return match ? ' docIconSm_' + match[1] : '';
        },
        'url': function(filename) {
            return BM.htmlDir + '/bm' + BM.dot + 'doc/' + filename;
        }
    },
    'image' : {
        'self' : '<strong>{title}</strong><br />{@imageInfo($)}',
        'imageInfo' : function(self) {
            if (!self.formats || !self.formats.length) return '';
            var format = new Object;
            var thumb;
            for( var i = 0; i<self.formats.length; i+=2) {
                if (self.formats[i] == '60x60') {
                  thumb = BM.htmlDir + '/bm' + BM.dot + 'pix/' + self.formats[i+1];
                  break;
                }
            }
            return thumb ? '<img src="' + thumb + '" alt="" /><br />' : '';
        }
     },
    'person' : {
        'self' : '<strong>{first_name} {last_name}</strong>'
          + '<div class="bmcpSupportText">{@titleInfo($)}'
          + '{@email($.email)}{@url($.url)}</div>',
        'titleInfo' : function(self) {
            var title = self.title;
            if (title && self.company) {
                title += ', ' + self.company;
            }
            else if (self.company) {
                title = self.company;
            }
            return title ? '<p><em>' + title + '</em></p>' : '';
        },
        'email' : function(email) {
            return email ? '<p><a href="mailto:' + email + '">'+ email + '</a></p>' : '';
        },
        'url' : function(url) {
            if (!url) return '';
            var text = url;
            if (text.length > 30) text = text.substr(0,30) + '...';
            return url ? '<p><a href="' + url + '" class="preview">' + text + '</a></p>' : '';
        }
     }
};
BM.Browser.titleRule = {
    'generic' : { 'title' : '{$.title}' },
    'document' : {
        'title' : '<span class="docIconSm{@iconClass($.filename)}" style="display:block">'
          + '{$.title}<\/span>',
        'iconClass' : function(filename) {
            var match = filename.match(/\.([a-zA-Z0-9]+)$/);
            return match ? ' docIconSm_' + match[1] : '';
        }
    },
    'person' : {
        'title' : '{$.first_name} {$.last_name}'
    },
    'page' : {
        'title' : '<span {@pubclass($)}>{$.title}</span>',
        'pubclass' : function(self) {
            return (!self.pub_status || self.pub_status != 'published')
              ? 'class="bmcpUnPub"' : '';
        }
    }
}

BM.Browser.prototype = {
    initialize : function(option) {
        if (!option) option = {};
        if (! (this.objType = option.objType) ) return;
        var suffix = option.suffix;
        if (!suffix) {
            if (! (this.relation = option.relation) ) return;
            var suffix = this.relation + '-' + this.objType;
        }
        BM.Browser.data = {}; // sorry, just one browser at a time
        if ( !(this.nav = $('BM_BROWSE_NAV_' + suffix) ) ) return;
        if ( !(this.browser = $('BM_BROWSE_' + suffix) ) ) return;
        if ( !(this.preview = $('BM_BROWSE_PREV_' + suffix) ) ) return;
        if ( !(this.idField = $('BM_LIB_ID_' + suffix) ) ) return;
        this.suffix = suffix;
        this.pages = {};

        this.sortOrder = option.sortOrder || 'recent';
        this.nameSearch = option.nameSearch || '';

        var titleRule =
          BM.Browser.titleRule[this.objType] || BM.Browser.titleRule.generic;
        var title = titleRule.title;
        var rule = {
            "self": '<table class="contentTable" width="100%" cellpadding="1" '
              + 'cellspacing="1">\n{$}</table>',
            "self[*]": '<tr><td><a href="#" onclick="BM.Browser.select(\''
              + this.suffix + "','" + this.objType + "',{$.id});"
              + 'return false;">' + titleRule.title + '</td><td>{$.mod_time}</td></tr>'
        };
        Object.extend(rule,titleRule);
        this.jsont = rule;
        this.loadList({redraw:true});
    },
    psize : 25,
    loadList : function(option) {
        if (!option) option = {};
        var start = option.start || 1;
        var length = option.length || this.psize * 2;
        var end = start + length - 1;
        this.fill = option.fill || ['thisPage', 'nextPage'];
        var loading;
        this.wantRedraw = option.redraw;
        var sField = this.browser;
        if(this.wantRedraw) loading = function(){ BM.Ajax.inProgress(sField) };
        this.start = start;
        var success = this.catchUpdate.bind(this);
        var error = function(httpReq) {
            BM.Ajax.clearStatus(sField);
            var status = httpReq.statusText == 'OK' ? '' : ': ' + httpReq.statusText;
            BM.alert('<span class="bm_ajaxNotOK">' + BM.Lang._('Ajax:error')
              + status + '<\/span>'); 
        };
        var contentLabel = BM.Mini.contentLabel();
        if (!contentLabel) {
            BM.alert( BM.Lang._('Mini:Unknown content type or ID') );
            return;
        }
        var path, rm;
        if (this.objType == 'page') {
            path = [this.sortOrder, start + '-' + end, this.nameSearch];
            rm = 'ajax-pages';
        }
        else {
            path = [ contentLabel, this.relation, this.objType,
              this.sortOrder, start + '-' + end, this.nameSearch ];
            rm = 'ajax-miniobj';
        }
        var url = BM.url( { script: 'bm-editor.cgi', rm: rm, path: path } );
        BM.Ajax.request(
            url,
            { 'method' : 'get', 'onLoading' : loading,
              'onSuccess' : success, 'onFailure' : error } );
    },
    catchUpdate : function(httpReq) {
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (this.wantRedraw) this.browser.innerHTML = '';
        if (BM.Ajax.loginRequired(ajaxJSON)) { //login
            return;
        }
        else if (ajaxJSON.error || !ajaxJSON.data) { // show error in modal
            var msg = ajaxJSON.error || ajaxJSON;
            BM.alert(msg);
        }
        else { // successful, update info
            var list = ajaxJSON.data.records;
            var pnum = Math.ceil(this.start/this.psize);
            this.numRecords = ajaxJSON.data.totalRecords;
            this.numPages = Math.ceil(this.numRecords/this.psize);
            list.each(function(item){BM.Browser.data[item.id] = item});
            var psize = this.psize, pages = this.pages;
            this.fill.each(function(page) {
                var size = list.length;
                if (size > psize) size = psize;
                if (size) {
                    pages[page] = { pnum: pnum, list:list.splice(0,size) }
                }
                else {
                    pages[page] = null;
                }
               pnum += 1;
            });
            if (this.wantRedraw) {
                this.redraw();
                this.wantRedraw = null;
            }
        }
    },
    redraw : function() {
        if (!this.pages.thisPage) {
            if (this.numRecords == 0) { // none to display
                this.browser.innerHTML = BM.Lang._('Browser:No items in the library.');
                this.drawNav();
            }
            else {
                this.showPage(this.numPages); // slipped past end
            }
            return;
        }
        var list = this.pages.thisPage.list;
        this.browser.innerHTML = BM.jsont(list, this.jsont);
        if (!this.idField.value && list[0]) {
            BM.Browser.select(this.suffix, this.objType, list[0].id);
        }
        this.drawNav();
    },
    drawNav : function() {
        if (!this.numRecords) {
            this.nav.innerHTML = '';
            return;
        }
        var pnum = this.pages['thisPage'].pnum;
        var pstart = ((pnum - 1) * this.psize) + 1;
        var pend = this.psize * pnum;
        if (pend > this.numRecords) pend = this.numRecords;

        this.nav.innerHTML = BM.Lang._('Browser:Browsing') + ' ' + pstart
          + '-' + pend + ' of '
          + this.numRecords + ' ' + BM.Lang._('Browser:items') + '.';
        if (this.numPages < 2) return;
        var navList = Builder.node('ul', {className:'bmw_overflowNav'});
        var prevText = BM.Lang._('Browser:Previous');
        if (pnum > 1) {
            navList.appendChild( this.navItem(pnum-1, pnum, prevText) );
        }
        else {
            navList.appendChild(
              Builder.node('span', {className:'bma_inertPage'}, prevText)
            );
        }
        
        var displayNum = 7;
        var startNav, endNav;
        if (this.numPages <= displayNum) {
            startNav = 1;
            endNav = displayNum;
            if (endNav > this.numPages) endNav = this.numPages;
        }
        else {
            startNav = pnum > displayNum/2 ? pnum - Math.floor(displayNum/2) : 1;
            endNav = startNav + displayNum - 1;
            if (endNav > this.numPages) {
                endNav = this.numPages;
                startNav = endNav - displayNum + 1;
            }
        }
        var b = this;
        $R(startNav,endNav).each(function(n){
            navList.appendChild(b.navItem(n, pnum))
        } );
        var nextText = BM.Lang._('Browser:Next');
        if (pnum < this.numPages) {
            navList.appendChild( this.navItem(pnum+1, pnum, nextText) );
        }
        else {
            navList.appendChild(
              Builder.node('span', {className:'bma_inertPage'}, nextText)
            );
        }
        this.nav.appendChild(navList);
    },
    navItem : function(n, pnum, label) {
        var className = n == pnum ? 'bma_thisPage' : '';
        if (!label) label = n;
        var b = this;
        var link = Builder.node('a', {className: className, href: '#'}, label);
        link.onclick = function(){b.showPage(n);return false};
        return Builder.node('li', [link]);
    },
    showPage : function(n) {
        var pnum = this.pages.thisPage ? this.pages.thisPage.pnum : 0;
        if (!pnum) { // confused, maybe from too many clicks too fast
            this.pages.nextPage = this.pages.prevPage = this.pages.thisPage;
        }
        else if ( !n || n == pnum || n > this.numPages ) {
            return;
        }
        else if ( n == pnum - 1 ) {
            this.pages.nextPage = this.pages.thisPage;
            this.pages.thisPage = this.pages.prevPage;
            this.pages.prevPage = null;
        }
        else if ( n == pnum + 1 ) {
            this.pages.prevPage = this.pages.thisPage;
            this.pages.thisPage = this.pages.nextPage;
            this.pages.nextPage = null;
        }
        else if ( n == pnum + 2 ) {
            this.pages.prevPage = this.pages.nextPage;
            this.pages.thisPage = null;
            this.pages.nextPage = null;
        }
        else if ( n == pnum - 2 ) {
            this.pages.nextPage = this.pages.prevPage;
            this.pages.thisPage = null;
            this.pages.prevPage = null;
        }
        else { // no current pages at all, refresh everything
            this.pages.nextPage = this.pages.prevPage = this.pages.thisPage = null;
        }
        
        //display if we have it, then collect for empty page(s)
        if (this.pages.thisPage) this.redraw();
        var toLoad = [];
        var start = 0, length = 0;
        var b = this;
        var prev = n - 3;
        ['prevPage', 'thisPage', 'nextPage'].each( function(p) {
            prev += 1;
            if (b.pages[p] && !start) return;
            if (prev < 0 || prev >= b.numPages) return;
            toLoad.push(p);
            if (!start) start = ( prev * b.psize ) + 1;
            length += b.psize;
            if ( (start + length - 1) > this.numRecords ) {
              length = this.numRecords - start + 1;
            }
        });
        if (start) {
            this.loadList( { start:start, length:length, fill:toLoad,
              redraw:!this.pages.thisPage } );
        }
    }

};

BM.Browser.select = function(suffix, type, id) {
    if (!id) return;
    var item = BM.Browser.data[id];
    if (!item) return;
    var rule = BM.Browser.rules[type] || BM.Browser.rules.generic;
    $('BM_BROWSE_PREV_' + suffix).innerHTML =
      '<div>' + BM.Lang._('Browser:Selected:') + ' </div>'
      + BM.jsont(item, rule);
    $('BM_LIB_ID_' + suffix).value = id;
};

BM.Browser.newSearch = function() {
    var type=$F('BM_MTYPE'), order=$F('BM_MSORT'), name=$F('BM_MFILTER');
    var match = type.match(/^(PAGE_.+)$/);
    if (match) {
        new BM.Browser( {suffix: match[1], objType: 'page', sortOrder: order,
          nameSearch: name} );
        return;
    }
    if ( !( match = type.match(/^(\S+?)\-(\S+?)$/) ) ) return;
    new BM.Browser({relation: match[1], objType: match[2],
      sortOrder:order, nameSearch:name});
}
