/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-imagesize.js 3042 2008-03-31 13:56:04Z josh $
*/

BM.Behavior.register( {
    '#ImageAddLink:click' : function(e,evt) {
        BM.ImageSize.addForm(e);
        Event.stop(evt); return false;
    },
    '#bmcpMainBody:click' : function(e,evt) {
      var cn = e.className || '';
      if ( cn.indexOf('deleteImage')!= -1 ) {
        BM.ImageSize.confirmDel(e);
        Event.stop(evt); return false;      
      }
    }
} );

/***************************************************************/
    BM.ImageSize = new Object;

/*  Handes new-image form for image size configuration
****************************************************************/

BM.ImageSize.addForm = function(trigger){
    var url = BM.url( { script: 'bm-siteconfig.cgi', rm: 'ajax-add-imagesize'} );
    var oncomplete = function(ajaxJSON, tempform) {
        if (!ajaxJSON.html) {
            BM.Ajax.showMessage(ajaxJSON, tempform.status);
            return false;
        }
        BM.Ajax.clearStatus(tempform.status);
        new Insertion.Bottom('bmfs_custom_images', ajaxJSON.html);
        return true;
    };
    var container = 'ImageAdd';

    var tempform = new BM.TempForm (
      { 
        id:     'ImageAddForm',
        method: 'post',
        action: url
      },
      { status: 'ImageAdd_AjaxStat',
        remote: 'ajax',
        oncomplete: oncomplete,
        trigger: {trigger: trigger, target: container }
      }
    );
    var fields = [
        [ 'simple_text', 'newimage_width',
          { label: BM.Lang._('ImageSize:Width'),
            description: BM.Lang._('ImageSize:Max width'),
            required: 1,
            validate_as: 'number_integer_positive'
          }
        ],
        [ 'simple_text', 'newimage_height',
          { label: BM.Lang._('ImageSize:Height'),
            description: BM.Lang._('ImageSize:Max height'),
            required: 1,
            validate_as: 'number_integer_positive'
          }
        ],
    ];
    tempform.addFields(fields);
    tempform.addSubmitCancel();
    tempform.addAsChildOf(container);
    tempform.show();
}


BM.ImageSize.confirmDel = function(link) {
    if (!(link = $(link)) || !link.id) return;
    //id format should be delete_60x60, so: param[0]=width, param[1]=height
    var param = link.id.replace(/^delete_/,'').split(/x/);
    if (!param[0] || !param[1]) return;
    var url = BM.url(
      {script: 'bm-siteconfig.cgi', rm: 'ajax-delete-imagesize'}
    );

    var modal;
    var loading = function() {
        modal = BM.alert('<div id="bmConfirmDelete"></div>');
        BM.Ajax.inProgress($('bmConfirmDelete'));
    };
    var success = function(httpReq) {
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON)) { //login
            modal.remove();
        }
        else if (ajaxJSON.error || !ajaxJSON.valid) { // show error in modal
            var msg = ajaxJSON.error || ajaxJSON;
            modal.setContent(msg);
        }
        else { // successful
            var container = $('formatContainer_' + param[0] + 'x' + param[1]);
            if (container) Element.remove(container);
            modal.remove();
        }
    };
    var error = function(httpReq) {
        var status = httpReq.statusText == 'OK' ? '' : ': ' + httpReq.statusText;
        var msg = '<span class="bm_ajaxNotOK">' + BM.Lang._('Ajax:error')
          + status + '</span>'; 
        modal.setContent(msg);
    };
    var params = 'delete_width=' + param[0] + '&delete_height=' + param[1];
    var action = function() {
        BM.Ajax.request(
            url,
            { 'method' : 'post',
              'postBody' : params,
              'onLoading' : loading,
              'onSuccess' : success,
              'onFailure' : error
            }
        );
    };
    new BM.Confirm(
        {message:BM.Lang._('ImageSize:Really delete?'), 'action':action}
    );
};
