/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-prefs.js 3233 2008-08-21 12:47:26Z josh $
*/

BM.Behavior.register( {
    '#bmcpMainBody:click' : function(e,evt) {
      if (e.tagName == 'A' && e.hasClassName('prefdel')) {
          BM.Pref.confirmDel(e);
          Event.stop(evt); return false;
      }
    }
});

/***************************************************************/
    BM.Pref = new Object;

/*  Functions specific to preference editing
****************************************************************/

BM.Pref.confirmDel = function(link) {
    if (!(link = $(link)) || !link.id) return;
    //id format should be BMPD-secid-format.group
    var param = link.id.split(/-/);
    param.shift(); // ditch the BMPD
    var url = BM.url(
      {script: 'bm-prefs.cgi', rm: 'ajax-delete-group', path: param}
    );
    var thisSec = param[0];
    var group = param[1];
    var statCell = $( "BMPS-" + thisSec + "-" + group);
    
    var listItem = link.parentNode;
    var loading = function() { BM.Ajax.inProgress(statCell); };
    var returnState = function() { if (statCell) statCell.innerHTML= '' };
    var success = function(httpReq) {
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON)) { //login
            returnState();
        }
        else if (ajaxJSON.error || !ajaxJSON.html) { // show error in modal
            returnState();
            var msg = ajaxJSON.error || ajaxJSON;
            BM.alert(msg);
        }
        else { // successful
            returnState();
            if (listItem) {
                listItem.innerHTML = ajaxJSON.html;
                BM.FX.flash( listItem,
                  {startcolor:'#ff6666', endcolor:'#ffffff', restorecolor:'#ffffff'}
                );
            }
        }
    };
    var error = function(httpReq) {
        returnState();
        var status = httpReq.statusText == 'OK' ? '' : ': ' + httpReq.statusText;
        var msg = '<span class="bm_ajaxNotOK">' + BM.Lang._('Ajax:error')
          + status + '</span>'; 
        BM.alert(msg);
    };
    var action = function() {
        BM.Ajax.request(
            url,
            { 'method' : 'post',
              'onLoading' : loading,
              'onSuccess' : success,
              'onFailure' : error
            }
        );
    };
    new BM.Confirm(
        {message:BM.Lang._('Pref:Really delete?'), 'action':action}
    );
};
