/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-sections.js 3042 2008-03-31 13:56:04Z josh $
*/

BM.Behavior.register( {
    '#reorderForm:submit' : function(e,evt) {
        $('sec_order').value = BM.Sort.serialize('AllSections');
    },
    '#AllSections:click' : function(e,evt) {
        var a = e.tagName == 'A'        ? e
          : e.parentNode.tagName == 'A' ? e.parentNode
          : null;
        if (!a) return;
        var c = a.className || '';
        if (c.indexOf('sectionLink') != -1) {
            BM.Sections.toggleDetails(a);
            Event.stop(evt); return false;
        }
        else if (c.indexOf('addSection') != -1 ) {
            BM.Sections.addForm(a);
            Event.stop(evt); return false;
        }
        else if (c.indexOf('deleteSec') != -1 ) {
            BM.Sections.confirmDelete(a);
            Event.stop(evt); return false;
        }
        else if (c.indexOf('editSec') != -1 ) {
            BM.Sections.toggleEdit(a);
            Event.stop(evt); return false;
        }
        else if (c.indexOf('editHome') != -1 ) {
            BM.Sections.toggleEdit(a,'home');
            Event.stop(evt); return false;
        }
    }
} );


/***************************************************************/
    BM.Sections = new Object;

/*  Functions specific to the section editor, for adding
    and editing sections in the list outline
****************************************************************/

BM.Sections.toggleDetails = function(trigger){
    var list_item = $(trigger).up('li');
    if(!list_item) return false;
    var match = list_item.id.match(/_(\d+)$/);
    if (!match) return false;
    BM.FX.toggle(trigger, 'section_' + match[1] + '_details', {effect:'slide'});
}

BM.Sections.addForm = function(trigger){
    var match = trigger.id.match(/^addsection_(\d+)$/);
    if (!match) return false;
    var secID = match[1];
    var url = BM.url( { script: 'bm-sections.cgi', rm: 'ajax-add-section'} );
    var oncomplete = function(ajaxJSON, tempform) {
        if (!ajaxJSON.html) {
            BM.Ajax.showMessage(ajaxJSON, tempform.status);
            return false;
        }
        BM.Ajax.clearStatus(tempform.status);
        new Insertion.Bottom('section' + secID, ajaxJSON.html);
        BM.Sort.init('AllSections');
        return true;
    };
    var container = 'sectionAdd_' + secID;

    var status = 'SectionAdd_' + secID + 'AjaxStat';
    var tempform = new BM.TempForm (
      { 
        id:     'SectionAddForm_' + secID,
        method: 'post',
        action: url
      },
      { status: status,
        onremove:function(){var s=$(status);if(s){s.innerHTML=''}return true;},
        remote: 'ajax',
        oncomplete: oncomplete,
        trigger: {trigger: trigger, target: container }
      }
    );
    var fields = [
        [ 'hidden', 'parent', {value: secID} ],
        [ 'simple_text', 'name',
          { label: BM.Lang._('Sections:Section Name'),
            description: BM.Lang._('Sections:Name of new section'),
            required: 1,
            validate_as: 'simple_text'
          }
        ],
        [ 'url_safe', 'slug',
          { label: BM.Lang._('Sections:Section Slug'),
            description: BM.Lang._('Sections:Slug name for new section'),
            required: 1,
            validate_as: 'url_safe',
            error: BM.Lang._('Sections:Slug validation error')
          }
        ]        
    ];
    tempform.addFields(fields);
    tempform.addSubmitCancel();
    tempform.addAsChildOf(container);
    tempform.show();
}

BM.Sections.editForm = function(option) {
    var runmode, name_label, name_desc;
    if (option.type == 'home') {
        runmode = 'ajax-edit-home';
        name_label = BM.Lang._('Sections:New Homepage Title');
        name_desc = BM.Lang._('Sections:Name to use for homepage in site navigation');
    }
    else {
        runmode = 'ajax-edit-section';
        name_label = BM.Lang._('Sections:New Section Name');
        name_desc = BM.Lang._('Sections:New name for the section');
    }
    var secID = option.id;
    var container = $('sectionEdit_' + secID);
    var secname = $('secName_'+secID).firstChild;

    var oncomplete = function(ajaxJSON, tempform) {
        if (!ajaxJSON.data) {
            var preamble = BM.Lang._('Sections:Could not edit the section');
            BM.Ajax.showMessage(ajaxJSON, tempform.status, preamble);
            return false;
        }
            
        /* firefox is happier putting the secname into a span instead of
           the actual link */
        var secname = $('secName_'+secID).firstChild;
        secname.innerHTML = ajaxJSON.data.name;
        if (ajaxJSON.data.slug) { // it's a section edit
            BM.FX.flash(secname, {
                startcolor: '#ffff99',
                endcolor: '#ffdd77',
                restorecolor: '#ffdd77',
                duration: 2.0
            });
            var secslug = $('secSlug_'+secID);
            secslug.innerHTML = ajaxJSON.data.slug;
            BM.FX.flash(secslug, {
                startcolor: '#ffff99',
                endcolor: '#ffcc66',
                restorecolor: '#ffcc66',
                duration: 2.0
            });
       }
        else { //flash the homepage (different colors)
            BM.FX.flash(secname, {
                startcolor: '#ffff99',
                endcolor: '#deefef',
                restorecolor: '#deefef',
                duration: 2.0
            });
        }
        BM.Ajax.clearStatus(tempform.status);
        return true;
    };
    
    var status='Section' + secID + 'AjaxStat';
    var newForm = new BM.TempForm (
      { method: 'post',
        action: BM.url( { script: 'bm-sections.cgi', rm: runmode} )
      },
      { remote: 'ajax',
        toggle: option.toggle,
        status: status,
        onremove:function(){var s=$(status);if(s){s.innerHTML=''}return true;},
        oncomplete: oncomplete
      }
    );
    var nameValue = secname.innerHTML;
    var fields = [
        [ 'hidden', 'section_id', {value: secID} ],
        [ 'simple_text', 'name',
          { label: name_label,
            description: name_desc,
            required: 1,
            validate_as: 'simple_text',
            value: nameValue
          }
        ]
    ];
    
   if (option.type != 'home') {
        var slugValue = secID && $('secSlug_' + secID)
                      ? $('secSlug_' + secID).innerHTML : '';
        fields.push( [ 'url_safe', 'slug',
          { label: BM.Lang._('Sections:New Section Slug'),
            description: BM.Lang._('Sections:New slug name for the section'),
            value: slugValue,
            required: 1,
            validate_as: 'url_safe',
            error: BM.Lang._('Sections:Slug validation error')
          }
        ]);
    }
    newForm.addFields(fields);
    newForm.addSubmitCancel();
    newForm.addAsChildOf(container);
    newForm.show();
}

BM.Sections.toggleEdit = function(link, type) {
    var match = link.id.match(/_(\d+)$/);
    if (!match) return false;
    var secID = match[1];
    var container = $('sectionEdit_' + secID);
    if (container.style.display == 'none') {
        BM.Sections.editForm(
            { id:secID, type:type, toggle: {trigger:link, target:container} }
        );
    }
    else {
        BM.FX.toggle(link,container,{effect:'slide'});
    }
}

BM.Sections.confirmDelete = function(link) {
    if (!link) return;
    var msg = BM.Lang._('Sections:Really delete this section?');
    var status =
      Element.getElementsBySelector(link.up(), ".bmcp_ajax_statusbar")[0];
    var loading = function() { BM.Ajax.inProgress(status) };
    var success = function(httpReq) {
        BM.Ajax.clearStatus(status);
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON)) { //login
            return;
        }
        else if (ajaxJSON.error || !ajaxJSON.valid) { // show error in modal
            var msg = ajaxJSON.error || ajaxJSON;
            BM.alert(msg);
        }
        else { // successful, take it off the page
            var item = link.up('li');
            if (item) {
                BM.FX.hide(item,{effect:'squish'});
                setTimeout(function(){item.remove()}, 2000);
            }
        }
    };
    var error = function(httpReq) {
        BM.Ajax.clearStatus(status);
        var status = httpReq.statusText == 'OK' ? '' : ': ' + httpReq.statusText;
        BM.alert('<span class="bm_ajaxNotOK">' + BM.Lang._('Ajax:error')
          + status + '</span>'); 
    };
    new BM.Confirm( { 
        message: msg,
        action: function() { BM.Ajax.request(
          link.href,
          { 'method' : 'post', 'onLoading' : loading,
            'onSuccess' : success, 'onFailure' : error } );
        }
    });
}

