/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-templates.js 3042 2008-03-31 13:56:04Z josh $
*/

BM.Behavior.register( {
    '#bmcpMainBody:click' : function(e,evt) {
      if (e.tagName == 'A' && e.hasClassName('delete')) {
        BM.Tmpl.confirmDel(e);
        Event.stop(evt); return false;
      }
    }
});

/***************************************************************/
    BM.Tmpl = new Object;

/*  Functions specific to editing templates
****************************************************************/

BM.Tmpl.confirmDel = function(link) {
    if (!(link = $(link)) || !link.id) return;
    //id format should be BMTD-format-template-id
    var param = link.id.split(/-/);
    param.shift(); // ditch the BMTD
    var url = BM.url(
      {script: 'bm-templates.cgi', rm: 'ajax-delete', path: param}
    );
    var template = param[1];
    var thisSec = param[2];
    var statCell = $( BM.Tmpl.statusID(template,thisSec) );
    
    var cell = link.parentNode;
    var row = cell ? cell.parentNode : null;
    var loading = function() { cell.innerHTML = BM.Ajax.progressHTML };
    var returnState = function() {
        cell.innerHTML= '';
        cell.appendChild(link);
    };
    var success = function(httpReq) {
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON)) { //login
            returnState();
        }
        else if (ajaxJSON.error || !ajaxJSON.valid) { // show error in modal
            returnState();
            var msg = ajaxJSON.error || ajaxJSON;
            BM.alert(msg);
        }
        else { // successful
            cell.innerHTML = '';
            if (statCell) statCell.innerHTML = ajaxJSON.statusHTML;
            if (row) {
                var color = Element.hasClassName(row, 'odd') ? '#deefef' : '#eeffff';
                BM.FX.flash( row,
                  {startcolor:'#ff6666', endcolor:color, restorecolor:color}
                );
            }
            if (ajaxJSON.subs) {
                ajaxJSON.subs.each( function(id) {
                    var status = BM.Tmpl.statusID(template,id);
                    if ( !( status = $(status) ) ) return;
                    status.innerHTML = ajaxJSON.subHTML;
                });
            }
        }
    };
    var error = function(httpReq) {
        returnState();
        var status = httpReq.statusText == 'OK' ? '' : ': ' + httpReq.statusText;
        var msg = '<span class="bm_ajaxNotOK">' + BM.Lang._('Ajax:error')
          + status + '</span>'; 
        BM.alert(msg);
    };
    var action = function() {
        BM.Ajax.request(
            url,
            { 'method' : 'post',
              'onLoading' : loading,
              'onSuccess' : success,
              'onFailure' : error
            }
        );
    };
    new BM.Confirm(
        {message:BM.Lang._('Tmpl:Really delete?'), 'action':action}
    );
};

BM.Tmpl.statusID = function(template,secID) {
    if (!template) return '';
    return secID ? 'BMTS-' + template + '-' + secID : 'BMTS-' + template;
}