/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-theme.js 3042 2008-03-31 13:56:04Z josh $
*/

BM.addLoadEvent( function() { //add post-validation callback to handle form
    var form = $('form_save-to-library');
    if (!form) return;
    form.onvalidate = function() {
      var checker = $('theme_checked');
      if (checker.value) {
        checker.value = ''; //in case we have to re-present the form
        return true;
      }
      BM.Themes.checkSlug();
      return false;
    };
    form = null;
} );

BM.Behavior.register( {
    '#bmThemes a.bmcpApplyTheme:click' : function(e,evt) {
         new BM.Confirm( {
           message:BM.Lang._('Theme:Really apply theme?'),
           action:function() { BM.postRequest(e.href) }
         } );
        Event.stop(evt); return false;
    },
    '#bmThemes a.bmcpApplyFirst:click' : function(e,evt) { //no confirmation
        BM.postRequest(e.href);
        Event.stop(evt); return false;
    },
    '#bmcpRemoveTheme:click' : function(e,evt) {
        new BM.Confirm( {
           message:BM.Lang._('Theme:Really remove theme?'),
           action:function() { BM.postRequest(e.href) }
         } );
        Event.stop(evt); return false;
    }
} );

BM.Themes={
    checkSlug : function() {
        var slug = $F('theme_slug');
        $('theme_checked').value='';
        var url = BM.url(
          {script:'bm-themes.cgi', rm:'ajax-check-slug', path:slug} );
        BM.Ajax.requestWithStatus(url,BM.Themes.checkSlugResponse);
    },
    checkSlugResponse : function( httpReq, statusObj, modal ) {
        var ajaxJSON = BM.Ajax.parseJSON(httpReq);
        if (BM.Ajax.loginRequired(ajaxJSON)) {
            modal.remove();
        }
        else if (!ajaxJSON.data) {
            BM.Ajax.showMessage(ajaxJSON, statusObj);
        }
        else if (ajaxJSON.data.avail == 'ok') {
            BM.Themes.realSubmit();
        }
        else {
            var name = ajaxJSON.data.taken || 'Untitled';
            var message = BM.Lang._('Theme:Theme already exists with slug:')
              + name + '<br /><br />'
              + BM.Lang._('Theme:Replace the theme in the library?')
            BM.Ajax.clearStatus(statusObj);
            new BM.Confirm({
                modal:modal,
                action : BM.Themes.realSubmit,
                message : message
              });
        }
        statusObj = modal = null;
    },
    realSubmit : function() {
            $('theme_checked').value = '1';
            $('form_save-to-library').submit();
    }
};