# Copyright 2002-2008 Josh Clark and Global Moxie, LLC. This code cannot be
# redistributed without permission from globalmoxie.com.  For more
# information, consult your Big Medium license.
#
# $Id: Help.pm 3043 2008-03-31 14:00:38Z josh $

package BigMed::App::Web::Help;
use strict;
use warnings;
use utf8;
use Carp;
$Carp::Verbose = 1;
use base qw(BigMed::App::Web::CP);

sub setup {
    my $app = shift;
    $app->start_mode('menu');
    $app->run_modes(
        'AUTOLOAD' => sub { $_[0]->rm_menu() },
        'menu'     => 'rm_menu',
        'markdown' => sub { $_[0]->show_help_page('markdown') }
    );
    return;
}

sub rm_menu {
    $_[0]->set_cp_breadcrumbs( { bc_label => 'BM_Coming Soon' }, );
    return $_[0]->html_template_screen(
        'screen_cp_generic.tmpl',
        bmcp_title => $_[0]->language('BM_Coming Soon'),
        message    => $_[0]->language('BM_TEXT_Coming Soon'),
    );
}

sub show_help_page {
    my ( $app, $screen ) = @_;
    return $app->html_template_screen( "screen_help_$screen.tmpl",
        bmcp_title => $app->language("HELP_TITLE_$screen"), );
}

1;

__END__

