# Copyright 2002-2008 Josh Clark and Global Moxie, LLC. This code cannot be 
# redistributed without permission from globalmoxie.com.  For more
# information, consult your Big Medium license.
#
# $Id: BadLogin.pm 3043 2008-03-31 14:00:38Z josh $

package BigMed::BadLogin;
use strict;
use utf8;
use Carp;
use base qw(BigMed::Data);


###########################################################
# SET BADLOGIN DATA SCHEMA
###########################################################

my @data_schema = (
    {
        name     => 'ip',
        type     => 'simple_text',
        index    => 1,
        unique   => 1,
        default  => '',
    },
    {
        name     => 'username',
        type     => 'username',
        index    => 1,
        default  => '',
    },
);

BigMed::Site->set_schema(
    source     => 'badlogins',
    label      => 'Bad Login',
    elements   => \@data_schema,
    systemwide => 1
);
