# Copyright 2002-2008 Josh Clark and Global Moxie, LLC. This code cannot be 
# redistributed without permission from globalmoxie.com.  For more
# information, consult your Big Medium license.
#
# $Id: PageVersion.pm 3043 2008-03-31 14:00:38Z josh $

package BigMed::PageVersion;
use strict;
use warnings;
use utf8;
use Carp;
use base qw(BigMed::Data);

###########################################################
# SET PAGEVERSION DATA SCHEMA
###########################################################

BigMed::PageVersion->set_schema(
    elements => [
        {   name  => 'site',
            type  => 'system_id',
            index => 1,
        },
        {   name  => 'page',
            type  => 'id',
            index => 1,
        },
        {   name  => 'version',
            type  => 'number_zeroplus_integer',
            index => 1,
        },
        {   name             => 'content',
            type             => 'rich_text',
            keep_line_breaks => 1,
            default          => '',
        },
        {   name             => 'editor',
            type             => 'id',
        },
    ]
);

1;

__END__
