# Copyright 2002-2008 Josh Clark and Global Moxie, LLC. This code cannot be
# redistributed without permission from globalmoxie.com.  For more
# information, consult your Big Medium license.
#
# $Id: NL.pm 3043 2008-03-31 14:00:38Z josh $

package BigMed::Search::Stopwords::NL;
use strict;
use warnings;
use utf8;

my @STOPWORDS = qw(
    de     en     van    ik      te     dat
    die    in     een    hij     het    niet
    zijn   is     was    op      aan    met
    als    voor   had    er      maar   om
    hem    dan    zou    of      wat    mijn
    men    dit    zo     door    over   ze
    zich   bij    ook    tot     je     mij
    uit    der    daar   haar    naar   heb
    hoe    heeft  hebben deze    u      want
    nog    zal    me     zij     nu     ge
    geen   omdat  iets   worden  toch   al
    waren  veel   meer   doen    toen   moet
    ben    zonder kan    hun     dus    alles
    onder  ja     eens   hier    wie    werd
    altijd doch   wordt  wezen   kunnen ons
    zelf   tegen  na     reeds   wil    kon
    niets  uw     iemand geweest andere
);

my %STOPWORDS;
@STOPWORDS{@STOPWORDS} = 1 x @STOPWORDS;
sub hashref { return {%STOPWORDS} }

1;
__END__


=head1 NAME

BigMed::Search::Stopwords::NL - Dutch stopword support

=head1 DESCRIPTION

This module is used internally by BigMed::Search::Stopwords.

=head1 AUTHOR & COPYRIGHTS

This module and all Big Medium modules are copyright Josh Clark
and Global Moxie. All rights reserved.

Use of this module and the Big Medium content
management system are governed by Global Moxie's software licenses
and may not be used outside of the terms and conditions outlined
there.

For more information, visit the Global Moxie website at
L<http://globalmoxie.com/>.

Big Medium and Global Moxie are service marks of Global Moxie
and Josh Clark. All rights reserved.

=cut

